#include "PositionVector.h"

namespace game
{
  PositionVector::PositionVector(const int x, const int y)
  {
    this->x = x;
    this->y = y;
  }

  void PositionVector::update(const int& x, const int& y)
  {
    this->x = x;
    this->y = y;
  }

  void PositionVector::change_x(const int& amount) {
      this->x += amount;
  }

  void PositionVector::change_y(const int& amount) {
      this->y += amount;
  }

  void PositionVector::normalize() {
      if (this->x < 0)
          this->x *= -1;
      if (this->y < 0)
          this->y *= -1;
  }

  bool PositionVector::eq(const PositionVector& position) const {
      return this->x == position.x && this->y == position.y;
  }
} // game
