#ifndef POSITION_H
#define POSITION_H

namespace game
{
    /// Ein Vector aus zwei zahlen.
    /// Kann eine Position oder eine Differenz zwischen zwei Positionen darstellen.
    struct PositionVector
    {
        // struct -> members public by default
        // Die beiden Variablen des Vectors
        int x;
        int y;

        /// Ein Vector aus zwei zahlen.
        /// Kann eine Position oder eine Differenz zwischen zwei Positionen darstellen.
        /// @param x Die 'X'-Koordinate
        /// @param y Die 'Y'-Koordinate
        PositionVector(int x, int y);

        /// Aktualisiere die Werte des Vectors
        /// @param x Die neue 'X'-Koordinate
        /// @param y Die neue 'Y'-Koordinate
        void update(const int& x, const int& y);

        void change_x(const int& amount);
        void change_y(const int& amount);

        void normalize();

        bool eq(const PositionVector& position)const ;
    };
} // game

#endif //POSITION_H
